# Description: Program that receives and displays temperature data from the serial port.
# Create by: Francis
# Date: may 2019

from PyQt5 import QtCore, QtGui, QtWidgets
from threading import Thread
import serial

GUIOBJECT = 0 # Global variable for the GUI
TEMPSERIAL = 0 # Global variable for the data from the serial port.
class Ui_MyGUI(object):
    def setupUi(self, MainWindow):
        MainWindow.setObjectName("MainWindow")
        MainWindow.resize(762, 600)
        self.centralwidget = QtWidgets.QWidget(MainWindow)
        self.centralwidget.setObjectName("centralwidget")
        self.lcdNumber = QtWidgets.QLCDNumber(self.centralwidget)
        self.lcdNumber.setGeometry(QtCore.QRect(270, 160, 401, 201))
        self.lcdNumber.setProperty("intValue", 10)
        self.lcdNumber.setObjectName("lcdNumber")
        self.Thermometer = QtWidgets.QProgressBar(self.centralwidget)
        self.Thermometer.setGeometry(QtCore.QRect(90, 140, 151, 341))
        self.Thermometer.setMaximum(30)
        self.Thermometer.setProperty("value", 24)
        self.Thermometer.setOrientation(QtCore.Qt.Vertical)
        self.Thermometer.setFormat("%p%")
        self.Thermometer.setObjectName("Thermometer")
        self.label = QtWidgets.QLabel(self.centralwidget)
        self.label.setGeometry(QtCore.QRect(240, 20, 281, 61))
        font = QtGui.QFont()
        font.setPointSize(26)
        self.label.setFont(font)
        self.label.setObjectName("label")
        self.label_2 = QtWidgets.QLabel(self.centralwidget)
        self.label_2.setGeometry(QtCore.QRect(100, 100, 141, 41))
        font = QtGui.QFont()
        font.setPointSize(16)
        self.label_2.setFont(font)
        self.label_2.setObjectName("label_2")
        self.label_3 = QtWidgets.QLabel(self.centralwidget)
        self.label_3.setGeometry(QtCore.QRect(100, 480, 141, 41))
        font = QtGui.QFont()
        font.setPointSize(16)
        self.label_3.setFont(font)
        self.label_3.setObjectName("label_3")
        self.label_4 = QtWidgets.QLabel(self.centralwidget)
        self.label_4.setGeometry(QtCore.QRect(450, 350, 261, 61))
        font = QtGui.QFont()
        font.setPointSize(20)
        self.label_4.setFont(font)
        self.label_4.setObjectName("label_4")
        MainWindow.setCentralWidget(self.centralwidget)
        self.statusbar = QtWidgets.QStatusBar(MainWindow)
        self.statusbar.setObjectName("statusbar")
        MainWindow.setStatusBar(self.statusbar)

        self.retranslateUi(MainWindow)
        QtCore.QMetaObject.connectSlotsByName(MainWindow)

    def retranslateUi(self, MainWindow):
        _translate = QtCore.QCoreApplication.translate
        MainWindow.setWindowTitle(_translate("MainWindow", "MainWindow"))
        self.label.setText(_translate("MainWindow", "Thermometer"))
        self.label_2.setText(_translate("MainWindow", "30 Celsius"))
        self.label_3.setText(_translate("MainWindow", "0 Celsius"))
        self.label_4.setText(_translate("MainWindow", "degrees celsius"))
class MainGUI_thread(Thread):

    def __init__(self):
        Thread.__init__(self)

    def run(self):
        global TEMPSERIAL  #Use global variable TEMPSERIAL
        global GUIOBJECT   #Use global variable GUIOBJECT
        app = QtWidgets.QApplication(sys.argv) # Create an app
        MainWindow = QtWidgets.QMainWindow()   # Create the main window
        GUIOBJECT = Ui_MyGUI()                 # Create a GUI object
        GUIOBJECT.setupUi(MainWindow)          # Setup the main window in my
                                               # Gui object
        UpdateThread = Update_thread()         # Create the thread Update.
        UpdateThread.start()                   # Start the thread Update.
        MainWindow.show()                      # Display the main window.
        sys.exit(app.exec_())                  # Exit the program when the main
                                               # windows is closed. 
        
class Update_thread(Thread):

    def __init__(self):
        Thread.__init__(self)

    def run(self):
        global GUIOBJECT  #Use global variable GUIOBJECT
        global TEMPSERIAL #Use global variable TEMPSERIAL
        Temp = 0.0; #Define a variable for temperature
        ser = serial.Serial('com3',9600)  # open serial port
        print(ser.is_open) #Print and check if the port is open
        print(ser.name)    # Print the name of the port	
        while 1: # For always
            line = ser.readline() # Read the line on serial port
            print(line) # Print the line from the serial port
            Temp = float(line) # Convert the string in float number
            try: # Manages exceptions 
                print(float(line)) # Print the number to display
                GUIOBJECT.lcdNumber.display(Temp)# Display the temperature on
                                                 # lcd display
            except ValueError:
                print("Value Error")# Print error
            Temp = int(Temp) # Convert the float in int for the thermometer display
            try: # Manages exceptions 
                GUIOBJECT.Thermometer.setValue(Temp)# Display the temperature on
                                                    # progress bar
            except ValueError:
                print("Value Error")# Print error

		
        
if __name__ == "__main__":

    import sys
    mainThread = MainGUI_thread() # Create the main thred for the GUI
    mainThread.start() # Start the thread for the GUI

